"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.query = void 0;
const swipl_1 = __importDefault(require("./swipl/swipl"));
const locateFile_1 = require("./locateFile");
function SWIPLIsomorphic(args) {
    return (0, swipl_1.default)(Object.assign({ locateFile: locateFile_1.locateFile, noInitialRun: true, arguments: ["-q"] }, args));
}
exports.default = SWIPLIsomorphic;
/**
 * A utility function for executing queries
 * @param str The query
 * @returns The results object
 */
function query(str) {
    return __awaiter(this, void 0, void 0, function* () {
        const swipl = yield SWIPLIsomorphic({});
        // See https://swi-prolog.discourse.group/t/swi-prolog-in-the-browser-using-wasm/5650/1
        return swipl.prolog.query(str);
    });
}
exports.query = query;
